%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 3
%global version_micro 19
%global serial 7
%global commitid 2b3343c7fa85a90b86470c81da1ebab21c132801

%{?scl:%scl_package mod_proxy_cluster}
%{!?scl:%global pkg_name %{name}}

# scldir points to the root dir of the jbcs collection
%define scldir /opt/rh/jbcs-httpd24/root

%define with_zip 1
%bcond_with zip

Name:		%{?scl_prefix}mod_proxy_cluster
Summary: 	JBoss mod_cluster for Apache httpd
Version: 	1.3.19
Release: 	%{serial}%{?dist}
Epoch:		0
License: 	LGPLv3
Group: 		Applications/System
URL:		http://www.jboss.org/
Source0:    mod_proxy_cluster-%{commitid}.tar.gz
Source1:    mod_proxy_cluster.conf
Source2:    mod_proxy_cluster.te
Source3:    mod_proxy_cluster.fc
Source4:    mod_cluster.conf
Obsoletes: %{?scl_prefix}mod_cluster-native < 0:%{version}-%{release}
Provides: %{?scl_prefix}mod_cluster-native = 0:%{version}-%{release}
Obsoletes: %{?scl_prefix}mod_cluster-native-debuginfo < 0:%{version}-%{release}
Provides: %{?scl_prefix}mod_cluster-native-debuginfo = 0:%{version}-%{release}

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:	%{?scl_prefix}httpd-devel
BuildRequires:	%{?scl_prefix}apr-devel
BuildRequires:	%{?scl_prefix}apr-util-devel
BuildRequires:	autoconf
BuildRequires:	zip
BuildRequires:  selinux-policy-devel

%if "%{?rhel}" <= "7"
Requires(post): policycoreutils-python
Requires(postun): policycoreutils-python
%else
Requires(post): python3-policycoreutils
Requires(postun): python3-policycoreutils
%endif

Requires:   %{?scl_prefix}httpd
Requires:   %{?scl_prefix}apr
Requires:   %{?scl_prefix}apr-util

%description
JBoss mod_cluster for Apache httpd

%if %with zip
%package src-zip
Summary:     Container for the source distribution of %{pkg_name}
Group:       Development

%description src-zip
Container for the source distribution of %{pkg_name}.
%endif

%prep
%setup -q -n %{pkg_name}-%{commitid}

%build
%if %with zip
zip -q -r ../%{name}-%{version}-src.zip native/*
%endif

%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)

pushd native
for i in advertise mod_manager mod_proxy_cluster mod_cluster_slotmem
do
pushd $i
%{?scl:scl enable %scl - << \EOF}
set -e
sh buildconf
./configure --with-apxs="%{apxs}"
make CFLAGS="%{optflags} -fno-strict-aliasing -DMOD_CLUSTER_RELEASE_VERSION=\\\"-%{serial}\\\""
%{?scl:EOF}
popd
done
popd

%install
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}

%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{pkg_name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT/%{aplibdir}/
cp -p native/*/*.so ${RPM_BUILD_ROOT}/%{aplibdir}/
install -d -m 755 $RPM_BUILD_ROOT/%{_localstatedir}/cache/mod_proxy_cluster

install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/
install -p -m 644 %{SOURCE1} \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_proxy_cluster.conf

# JBCS-1425
install -p -m 644 %{SOURCE4} \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_cluster.conf

# JBCS-167
sed -i -e 's@/var/cache/mod_proxy_cluster@%{scldir}/var/cache/mod_proxy_cluster@g' \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_proxy_cluster.conf

%if %with zip
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
install -p -m 644 ../%{name}-%{version}-src.zip \
        $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

# for SELinux
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}
mkdir selinux
pushd selinux
    cp -p %{SOURCE2} .
    cp -p %{SOURCE3} .

    make -f %{_root_datadir}/selinux/devel/Makefile
    install -p -m 644 -D %{pkg_name}.pp $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}/mod_proxy_cluster.pp
popd

%clean
rm -Rf $RPM_BUILD_ROOT

%post
if [ $1 -eq 1 ] ; then
    %{_root_sbindir}/semodule -i %{_datadir}/selinux/packages/%{name}/mod_proxy_cluster.pp 2>/dev/null || :
    %{_root_sbindir}/semanage port -a -t http_port_t -p udp 23364 >/dev/null 2>&1 || :
    %{_root_sbindir}/semanage port -a -t http_port_t -p tcp 6666 >/dev/null 2>&1 || :
    /sbin/restorecon -R %{scldir}/var/cache/mod_proxy_cluster >/dev/null 2>&1 || :
fi

# JBCS-1425
rm -f %{scldir}/etc/httpd/conf.d/mod_cluster.conf.rpmnew
if [ ! -s %{scldir}/etc/httpd/conf.d/mod_cluster.conf ] ; then
    rm -f %{scldir}/etc/httpd/conf.d/mod_cluster.conf
fi

%preun
if [ $1 -eq 0 ] ; then
    %{_root_sbindir}/semanage port -d -t http_port_t -p udp 23364 2>&1 || :
    %{_root_sbindir}/semanage port -d -t http_port_t -p tcp 6666 2>&1 || :
    %{_root_sbindir}/semodule -r mod_proxy_cluster >/dev/null 2>&1 || :
    /sbin/restorecon -R %{scldir}/var/cache/mod_proxy_cluster >/dev/null 2>&1 || :
fi

%files
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%defattr(0644,root,root,0755)
%doc lgpl.txt
%dir %{_localstatedir}/cache/mod_proxy_cluster
%attr(0755,root,root) %{aplibdir}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_proxy_cluster.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_cluster.conf
# for SELinux
%dir %{_datadir}/selinux/packages/%{name}
%{_datadir}/selinux/packages/%{name}/mod_proxy_cluster.pp

%if %with zip
%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/*
%endif

%changelog
* Sat Nov 18 2023 Sokratis Zappis <szappis@redhat.com> - 1.3.19-7
- Rebuild for 2.4.57.SP2

* Thu Oct 19 2023 Sokratis Zappis <szappis@redhat.com> - 1.3.19-5
- Rebuild for 2.4.57.SP1

* Thu Jun 29 2023 Sokratis Zappis <szappis@redhat.com> - 1.3.19-1
- Resolves [JBCS-1591] - Upgrade mod_proxy_cluster to version 1.3.19

* Wed Jun 21 2023 Mladen Turk <mturk@redhat.com> - 1.3.18-3
- Rebuild for httpd-2.4.57

* Wed May 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 1.3.18-2
- Built by CPaaS

* Tue Apr 25 2023 Sokratis Zappis <szappis@redhat.com> - 1.3.18-1
- Resolves [JBCS-1527] - Upgrade mod_proxy_cluster to version 1.3.18

* Mon Dec 05 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.17-13
- Rebuild for 2.4.51.SP1

* Tue Nov 15 2022 Dimitris Soumis <dsoumis@redhat.com> - 1.3.17-13
- Resolves [JBCS-1425] - 2.4.51 update breaks mod_cluster config

* Sat Oct 01 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.17-9
- Build for 2.4.51.CR2

* Wed Sep 28 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.17-8
- Resolves [JBCS-1387] - mod_proxy_cluster hcheck not working

* Tue Aug 23 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.17-1
- Build with tag 1.3.17.Final from upstream https://github.com/modcluster/mod_cluster/releases/tag/1.3.17.Final

* Tue Jul 19 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.16-19
- Add Obsoletes and Provides to resolve conflicts from package's renaming - [SPMM-10483]

* Tue Jul 12 2022 Mladen Turk <mturk@redhat.com> - 1.3.16-15
- Remove sample suffix from mod_proxy_cluster.conf

* Fri Jul 08 2022 Mladen Turk <mturk@redhat.com> - 1.3.16-14
- Revert adding 00-mod_proxy_cluster.conf.sample

* Thu Jul 07 2022 Mladen Turk <mturk@redhat.com> - 1.3.16-13
- Split and change conf file names, resolves [JBCS-1351]
- Use /var/cache/mod_proxy_cluster insted mod_cluster

* Thu Jul 07 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.16-12
- Resolves [JBCS-1073] - responsefieldsize needs to be configurable for mod_cluster

* Tue Jul 05 2022 Sokratis Zappis <szappis@redhat.com> - 1.3.16-11
- Changing conf file name, resolves [JBCS-1351]

* Mon Feb 14 2022 Mladen Turk <mturk@redhat.com> - 1.3.16-1
- Create new mod_proxy_cluster from mod_cluster-native

* Tue May 05 2020 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.14-1
- Upgrading to mod_cluster 1.3.14 [JBCS-941]

* Tue Mar 17 2020 George Zaronikas <gzaronik@redhat.com> - 1.3.12-39
- MODCLUSTER-714

* Fri Oct 11 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-9
- Rebuilding JBCS httpd 2.4.37-ER5

* Thu Oct 10 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-8
- JBCS httpd 2.4.37-ER5

* Wed Sep 25 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-7
- Building JCBS 2.4.37.ER4

* Mon Sep 23 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-6
- JBCS 2.4.37.ER3

* Thu Aug 29 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-4
- Enabled src zip in both dists

* Thu Aug 29 2019 Hui Wang <huwang@redhat.com> - 1.3.12-3
- Enable src-zip for rhel7

* Tue Aug 27 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-2
- Test build

* Wed Aug 21 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 1.3.12-1
- Updating to mod_cluster 1.3.12 [JBCS-803]

* Tue Aug 06 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.11-10
- JBCS 2.4.37.ER2

* Wed Jul 24 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.11-6
- JBCS 2.4.37.ER1

* Fri Jul 19 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.11-5
- JBCS 2.4.37.ER1

* Thu Jun 27 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 1.3.11-2
- Applied fix for [JBCS-405]

* Wed Jun 19 2019 Hui Wang <huwang@redhat.com> - 1.3.11-2
- Build with new httpd 2.4.37

* Wed Jun 19 2019 Hui Wang <huwang@redhat.com> - 1.3.11-1
- Build with new httpd 2.4.37

* Wed Jun 05 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 1.3.11-1
- Updating to mod_cluster 1.3.11 [JBCS-446]

* Thu Nov 01 2018 Sokratis Zappis <szappis@redhat.com> - 1.3.8-3
- Build for JBCS httpd 2.4.29 SP1 DR1

* Tue Mar 06 2018 Hui Wang <huwang@redhat.com> - 1.3.8-1
- Build with the latest commitId

* Tue Mar 06 2018 Jean-Frederic Clere <jclere@redhat.com> - 1.3.8-1
- retrying...

* Mon Mar 05 2018 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.3.8-1
- Build with httpd 2.4.29

* Mon Mar 05 2018 Jean-Frederic Clere <jclere@redhat.com> - 1.3.8-1
- Adjust to the new git repo.

* Tue Nov 07 2017 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.3.8-14
- Updating to 1.3.8

* Tue Nov 07 2017 George Zaronikas <gzaronik@redhat.com> - 1.3.8-1
- Updating to mod_cluster 1.3.8

* Tue Feb 07 2017 Jan Fnukal <hfnukal@redhat.com> - 1.3.5-14
- jbcs-httpd24 SP1

* Wed Oct 26 2016 Hui Wang <huwang@redhat.com> - 1.3.5-13
- Rebuild

* Wed Oct 26 2016 Jean-Frederic Clere <jclere@redhat.com> - 1.3.5-12
-

* Wed Oct 26 2016 Jean-Frederic Clere <jfclere@redhat.com> - 1.3.5-0
- 1.3.5.Final-redhat

* Fri Oct 21 2016 Permaine Cheung <pcheung@redhat.com> - 1.3.4-12
- 1.3.4.Final-redhat-1

* Wed Sep 28 2016 Coty Sutherland <csutherl@redhat.com> - 1.3.3-12
- Resolves: JBCS-167 mod_cluster-native uses /var/cache/mod_cluster instead of /opt/rh/jbcs-httpd24/root/var/cache/mod_cluster
- Resolves: JBCS-172 Update mod_cluster-native selinux policy

* Wed Jul 20 2016 Permaine Cheung <pcheung@redhat.com> - 1.3.3-11
- 1.3.3.Final-redhat-1

* Wed Jul 20 2016 Permaine Cheung <pcheung@redhat.com> - 1.3.3-1.Final-redhat-1
- 1.3.3

* Tue Feb 16 2016 Fernando Nasser <fnasser@redhat.com> - 1.3.1-10
- Build from source-repos

* Fri Feb 12 2016 Fernando Nasser <fnasser@redhat.com> - 1.3.1-9
- JCSP-24 postun scriptlet fails when unistalling mod_cluster-native

* Tue Dec 22 2015 Fernando Nasser <fnasser@redhat.com> - 0:1.3.1-7
- Build in the jbcs-httpd24 collection

* Tue Oct 20 2015 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-6.Final-redhat-2
- Rebuild

* Fri Apr 10 2015 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-5.Final-redhat-2
- 1.3.1.Final-redhat-2
- Remove patch for CVE-2015-0298 as it has been incorporated in the new tag

* Wed Mar 18 2015 Dustin Kut Moy Cheung <dcheung@redhat.com> - 0:1.3.1-4.Beta2-redhat-1
- add patch for CVE-2015-0298

* Mon Jan 26 2015 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-3.Beta1-redhat-1
- 1.3.1.Beta2-redhat-1

* Thu Dec 18 2014 Weinan Li <weli@redhat.com> - 0:1.3.1-2.Beta1
- Fix conf file

* Tue Nov 18 2014 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-1.Beta1
- 1.3.1.Beta1
- JWS 3.0 build
